(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: MECHREF3.PAS                                                   *)
(*  Obsah: 3. referat z mechaniky 1, zadani 6.                             *)
(*  Autor: Mircosoft                                                       *)
(*  Posledni uprava: ??? 2004                                              *)
(*  Pro kompilaci: viz USES                                                *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program Treti_referat_z_mechaniky_1_zadani_cislo_6;
uses matyka,{funkce pro pocitani s maticemi}
     vgastart,{pro nastartovani grafiky}
     graph,{standardni graficke veci}
     cas,{pro cekani}
     klavesy;{pro cteni stisknutych klaves (misto CRT)}
const
pomer=100;{tim se nasobi souradnice, aby vysly v pixelech a daly se nakreslit.
            Cim vetsi cislo, tim vetsi rozmery.}

realtime=50; zpomalene=100; rychle=5; superrychle=0;
rychlost=realtime;{rychlost animace, doporucuji pouzit preddefinovane
                   konstanty (realtime znamena, ze to bezi skutecnou zadanou
                   rychlosti)}

{zadane hodnoty:}
omega12=0.6;{[rad/s]}
omega23=-0.7;
v34=-0.25;{[m/s]}
s340=0.15;{[m]}
l2=0.4;
lB=0.47;
l4=0.25;
gama=-0.72;{[rad]}

var
o:char;{pomocna, pro klavesnici}

fi12,{[rad]}
fi23,
s34:real;{[m]}

{Tx(x) = [1 0 x        Ty(y) = [1 0 0       Tfi(fi) = [cos(fi) -sin(fi) 0
          0 1 0                 0 1 y                  sin(fi)  cos(fi) 0
          0 0 1]                0 0 1]                   0       0      1]
 (to jsou obecne transformacni matice pro rovinne soustavy)}

T34,Tpom,Tx34,T23,Tfi23,T12,Txl2,TfiGama,Tfi12:matice3x3;
vs34,vlB,vl4,v001,
rA,
rB,
rC,{kloub mezi 2 a 3}
rD,{spoj mezi 3 a 4}
rO{pocatek}
 :vektor3;

t:real;{cas [s]}

procedure cara(b1,b2:vektor3);{prepocita souradnice a nakresli caru}
Begin
line(round(320+b1[1]*pomer),round(240-b1[2]*pomer),round(320+b2[1]*pomer),round(240-b2[2]*pomer));
End;{cara}

BEGIN
setcolor(15);
{konstantni matice a vektory:}
ZadejMatici3x3(TfiGama, cos(gama), -sin(gama), 0,
                        sin(gama),  cos(gama), 0,   {takhle se zadavaji matice 3x3...}
                           0,          0,      1);
ZadejVektor3(rO, 0,
                 0,  {...a takhle triprvkove vektory, je jedno jestli radkove nebo sloupcove}
                 1);
zadejmatici3x3(Txl2, 1, 0, -l2,
                     0, 1, 0,
                     0, 0, 1);
zadejvektor3(v001, 0,
                   0,
                   1);
zadejvektor3(vlB, lB,
                  0,
                  1);
zadejvektor3(vl4, l4,
                  0,
                  1);
{nakresleni popisek:}
setcolor(12); outtextxy(10,10,'trajektorie bodu A');
setcolor(9); outtextxy(10,20,'trajektorie bodu B');
setcolor(7); outtextxy(10,30,'mechanismus');
outtextxy(1,450,'Mezernik = animace, cokoli jineho = krokovani.');
outtextxy(1,460,'Po skonceni animace Esc = konec, cokoli jineho = znovu.');
outtextxy(1,470,'Obrazovka by mela jit kdykoli vyfotit Printscreenem a ulozit v Paintbrushi.');
setwritemode(1);
 repeat{vnejsi cyklus - aby se program mohl spustit znova, kdyz dobehne}
 o:='s';
 t:=0;{vynulovani casu na zacatku}
  repeat{hlavni cyklus - animace}
  startcekani;{zaznamenani casu (ceka se az na konci cyklu)}
  {promenne zavisle na case:}
  fi12:=omega12*t;
  fi23:=omega23*t;
  s34:=s340+v34*t;
  {transformace:}
  zadejmatici3x3(Tfi12, cos(fi12), -sin(fi12), 0,
                        sin(fi12),  cos(fi12), 0,
                           0,          0,      1);
  SoucinMatic3x3(Tfi12,Txl2,T12);
  MaticexVektor3(t12,v001,rC);{maticovy soucin matice a vektoru}
  zadejmatici3x3(Tfi23, cos(fi23), -sin(fi23), 0,
                        sin(fi23),  cos(fi23), 0,
                           0,          0,      1);
  SoucinMatic3x3(T12,Tfi23,T23);{maticovy soucin dvou matic}
  maticexvektor3(T23,vlB,rB);
  zadejmatici3x3(Tx34, 1, 0, s34,
                       0, 1, 0,
                       0, 0, 1);
  soucinmatic3x3(T23,Tx34,Tpom);
  maticexvektor3(Tpom,v001,rD);
  soucinmatic3x3(Tpom,TfiGama,T34);
  maticexvektor3(T34,vl4,rA);
  {kresleni mechanismu:}
  cara(rO,rC);
  cara(rC,rB);
  cara(rD,rA);
  cara(rC,rD);{tohle je protazeni 'kolejnice' pres kloub, protoze podle
               originalniho zadani by se tam teleso 4 neveslo}
  if o<>' ' then o:=readkey;{pro krokovani animace}
  pockej(rychlost);{cekani pri animaci}
  cara(rO,rC);
  cara(rC,rB); {protoze je nastaveno setwritemode(1), tak se cary}
  cara(rD,rA); { druhym nakreslenim smazou                       }
  cara(rC,rD);
  {kresleni trajektorii dvou bodu na mechanismu:}
  putpixel(round(320+rA[1]*pomer),round(240-rA[2]*pomer),12);
  putpixel(round(320+rB[1]*pomer),round(240-rB[2]*pomer),9);
  t:=t+0.05;
  until t>7;{jede se do 7 sekund podle zadani}
 cara(rO,rC);
 cara(rC,rB);  {vykresleni v koncove poloze}
 cara(rD,rA);
 cara(rc,rd);
 o:=readkey;
 until o=#27;{vnejsi cyklus konci po stisku Esc}
konecgrafiky;
END.