(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: MECHREFX.PAS                                                   *)
(*  Obsah: 3. referat z mechaniky 1, nevim, co to bylo za cislo zadani     *)
(*  Autor: Mircosoft                                                       *)
(*  Posledni uprava: ??? 2004                                              *)
(*  Pro kompilaci: viz USES                                                *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program Treti_referat_z_mechaniky_1_zadani_cislo_x;
uses matyka,{funkce pro pocitani s maticemi}
     vgastart,{pro nastartovani grafiky}
     graph,{standardni graficke veci}
     cas,{pro cekani}
     klavesy;{pro cteni stisknutych klaves (misto CRT)}
const
pomer=100;{tim se nasobi souradnice, aby vysly v pixelech a daly se nakreslit.
            Cim vetsi cislo, tim vetsi rozmery.}

realtime=50; rychle=5; zpomalene=100; superrychle=0;
rychlost=50;{rychlost animace, doporucuji pouzit preddefinovane konstanty
             (realtime znamena, ze to bezi skutecnou zadanou rychlosti)}

{zadane hodnoty:}
omega12=0.6;{[rad/s]}
omega23=0.7;
omega34=0.5;
l2=0.4;
l3=0.3;
lB=0.47;
l4=0.25;
beta0=0.123;
delta0=0.65;
gama0=0.98;

var
o:char;{pomocna, pro klavesnici}
fi12,{[rad]}
fi23:real;

{Tx(x) = [1 0 x        Ty(y) = [1 0 0       Tfi(fi) = [cos(fi) -sin(fi) 0
          0 1 0                 0 1 y                  sin(fi)  cos(fi) 0
          0 0 1]                0 0 1]                   0       0      1]
 (to jsou obecne transformacni matice pro rovinne soustavy)}

Tdelta,Tgama,Tbeta,Txl4,Txl3,T34,Tpom,Tx34,T23,T12,Txl2:matice3x3;
vlB,vl4,v001,
rA,
rB,
rC,
rD,
rO{pocatek}
 :vektor3;
beta,gama,delta,
t:real;{cas [s]}

procedure cara(b1,b2:vektor3);{prepocita souradnice a nakresli caru}
Begin
line(round(320+b1[1]*pomer),round(240-b1[2]*pomer),round(320+b2[1]*pomer),round(240-b2[2]*pomer));
End;{cara}

BEGIN
setcolor(15);
{konstantni matice a vektory:}
zadejvektor3(vlB, lB,
                  0,
                  1);
zadejvektor3(rO, 0,
                 0,
                 1);

zadejmatici3x3(Txl2, 1, 0, l2,
                     0, 1, 0,
                     0, 0, 1);

zadejmatici3x3(Txl3, 1, 0, l3,
                     0, 1, 0,
                     0, 0, 1);

zadejmatici3x3(Txl4, 1, 0, l4,
                     0, 1, 0,
                     0, 0, 1);

zadejvektor3(v001, 0,
                   0,
                   1);
{kresleni popisek:}
setcolor(12); outtextxy(10,10,'trajektorie bodu A');
setcolor(9); outtextxy(10,20,'trajektorie bodu B');
setcolor(7); outtextxy(10,30,'mechanismus');
outtextxy(1,450,'Mezernik = animace, cokoli jineho = krokovani.');
outtextxy(1,460,'Po skonceni animace Esc = konec, cokoli jineho = znovu.');
outtextxy(1,470,'Obrazovka by mela jit kdykoli vyfotit Printscreenem a ulozit v Paintbrushi.');
setwritemode(1);
 repeat{vnejsi cyklus - aby se to mohlo spustit znova, kdyz to dobehne}
 o:='s';
 t:=0;{vynulovani casu na zacatku}
  repeat{hlavni cyklus - animace}
  startcekani;{zaznamenani casu (ceka se az na konci cyklu)}
  {promenne zavisle na case:}
  beta:=beta0+omega12*t;
  gama:=gama0-omega23*t;
  delta:=delta0+omega34*t;
  {vypocty a transformace:}
  zadejmatici3x3(Tbeta, cos(beta), -sin(beta), 0,
                        sin(beta),  cos(beta), 0,
                           0,          0,      1);
  soucinmatic3x3(Tbeta,Txl2,T12);
  maticexvektor3(T12,v001,rC);
  zadejmatici3x3(Tgama, cos(-gama), -sin(-gama), 0,
                        sin(-gama),  cos(-gama), 0,
                           0,          0,      1);
  soucinmatic3x3(T12,Tgama,T23);
  maticexvektor3(T23,vlB,rB);

  soucinmatic3x3(T23,Txl3,Tpom);
  maticexvektor3(Tpom,v001,rD);
  zadejmatici3x3(Tdelta, cos(-delta), -sin(-delta), 0,
                         sin(-delta),  cos(-delta), 0,
                              0,          0,      1);
  soucinmatic3x3(Tpom,Tdelta,T34);
  soucinmatic3x3(T34,txl4,tpom);
  maticexvektor3(tpom,v001,ra);
  {kresleni mechanismu:}
  cara(rO,rC);
  cara(rC,rd);
  cara(rd,rA);
  cara(rd,rb);{zase je spatne zadani, takze vzdalenost lB je vetsi nez delka prutu, na kterem bod B lezi.
               Takze prikreslim imaginarni caru, aby B nevisel jen tak ve vzduchu}
  if o<>' ' then o:=readkey;{pro krokovani animace}
  pockej(rychlost);{cekani pri animaci}
  cara(rO,rC);
  cara(rC,rd);
  cara(rd,rA);
  cara(rd,rb);
  {kresleni bodu:}
  putpixel(round(320+rA[1]*pomer),round(240-rA[2]*pomer),12);
  putpixel(round(320+rB[1]*pomer),round(240-rB[2]*pomer),9);
  t:=t+0.05;
  until t>7;{jede se az do 7 sekund}
 cara(rO,rC);
 cara(rC,rd);
 cara(rd,rA);
 o:=readkey;
 until o=#27;{vnejsi cyklus konci po stisku Esc}
konecgrafiky;
END.